(module finalize
   (import js-nodes
           js-parser
           js-out
           js-nodes-extra
           config
           verbose
           walk)
   (export (finalize! tree)))

(define LocalThis
   (make-Ref '_this))

(define This
   (make-Ref 'this))

(define (finalize! tree)
   (expand-var-decl! tree #f))

(define-nmethod (Node.expand-var-decl!)
   (default-walk! this)
   this)

(define-nmethod (Var-Program.expand-var-decl!)
   (default-walk! this)
   (with-access::Var-Program this (var-decl body)
      (with-access::Block body (stmts)
         (if var-decl
            (begin
                (set! stmts (cons var-decl stmts))
                (set! var-decl #f)))))
   this)

(define-nmethod (Var-Fun.expand-var-decl!)
   (default-walk! this)
   (with-access::Var-Fun this (params body var-decl)
      (with-access::Block body (stmts)
         (if var-decl
            (begin
               (set! stmts 
                  (cons
                     (make-Var-Decl-List (list LocalThis))
                     (cons
                        var-decl
                        (cons (make-Vassig LocalThis This) stmts))))
               (set! var-decl #f))
            (begin
               (set! stmts 
                  (cons
                     (make-Var-Decl-List (list (make-Init LocalThis This)))
                     stmts))))))
   this)