(module js2post
   (import js-nodes
           js-nodes-extra	
           js-parser
           js-out
           config
           verbose
           vardecl
           cpstrans
           trampoline
           optim-admin
           finalize)
   (export (js2post-compile-file in-p out-p varl trampolines)))

(define (js2post-compile-file in-p out-p varl trampolines)
   (let* ((tree (parse in-p
                   (lambda () (error "parse" "An error occured in parsing process" #f)))))
      
      (verbose "\n**Original Parsing Tree**:\n==================================")
      (verbose tree)

      (set! tree (var-decl-normal-form! tree))
      (set! tree (cps-transform! tree varl))
      (verbose "\n**CPS-transformed Tree**:\n==================================")
      (verbose tree)

      (optim-administrative! tree)
      (verbose "\n**Optimized (administrative steps) Tree**:\n==================================")
      (verbose tree)

      (if trampolines 
         (begin 
            (trampoline! tree)
            (verbose "\n**Trampoline-enabled Tree**:\n==================================")
            (verbose tree)) 
         (set! tree (make-final-application tree)))

      (finalize! tree)
      (verbose "\n**Trampoline-enabled Tree**:\n==================================")
      (verbose tree)

      ;;Write the result output port
      (js-out tree out-p :compress? #f)))

(define (make-final-application tree) 
   (with-access::Var-Program tree (body var-decl)
      (if (is-a? body Cps-Code)
         (let ((new-body  
                  (make-Block (list (make-Call body (list (make-Continu '() (make-Block (list (make-Undefined 0))))))))))
            (make-Var-Program new-body var-decl))
         tree)))