/*Future Classes*/

/*======================================================================================================================================================*/
/*=====STUB ABSTRACT CLASSES============================================================================================================================*/
/*======================================================================================================================================================*/

/*=====STUB ============================================================================================================================================*/
mashic.Stub = function () { 
}

mashic.Stub.prototype.isStub = true; 

mashic.Stub.prototype.setRealValue = function (val) { 
    this.realValue = val;
}

mashic.Stub.genStubId = (function () { 
    var firstId = 1; 
    return function () {
       return firstId++; 
    }
})(); 

mashic.Stub.getShallowStub = function () { 
    if (this.hasRealValue) { 
        return this.realValue;
    } else { 
        return {
            id: this.id,
            __is_shallow_stub: true
        };
    }
}

/*=====GADGET_STUB======================================================================================================================================*/
mashic.GadgetStub = function() { } 

mashic.GadgetStub.prototype = new mashic.Stub(); 

mashic.GadgetStub.prototype.processAccess = function(prop) {
  prop = (prop instanceof mashic.Stub) ? prop.getShallowStub() : prop;
  return new GadgetAccessStub(this.getShallowStub(), prop); 
}

/*=====PURE_INTEGRATOR_STUB=============================================================================================================================*/
mashic.PureIntegratorStub = function() { } 

mashic.PureIntegratorStub.prototype = new mashic.Stub(); 

mashic.PureIntegratorStub.prototype.processAccess = function(prop) { 
  prop = (prop instanceof mashic.Stub) ? prop.getShallowStub() : prop;
  return new PureIntegratorAccessStub(this.getShallowStub(), prop); 
}

/*=====INTEGRATOR_STUB==================================================================================================================================*/
mashic.IntegratorStub = function() { } 

mashic.IntegratorStub.prototype = new mashic.Stub(); 

mashic.IntegratorStub.prototype.processAccess = function(prop) { 
  prop = (prop instanceof mashic.Stub) ? prop.getShallowStub() : prop;
  return new UnknownAccessStub(this.getShallowStub(), prop); 
}

/*=====UNKNOWN_STUB=====================================================================================================================================*/
mashic.UnknownStub = function() { } 

mashic.UnknownStub.prototype = new mashic.Stub(); 

mashic.IntegratorStub.prototype.processAccess = function(prop) { 
  prop = (prop instanceof mashic.Stub) ? prop.getShallowStub() : prop;
  return new UnknownAccessStub(this.getShallowStub(), prop); 
}

/*======================================================================================================================================================*/
/*=====ACCESS===========================================================================================================================================*/ 
/*======================================================================================================================================================*/

/*=====RUNTIME==========================================================================================================================================*/
Object.prototype.processAccess(obj, prop) { 
  return obj[prop]; 
}

function __ACCESS(obj,prop) {
   return obj.processAccess(obj, prop); 
}

mashic.buildAccessStub = function(obj, prop) {    
    // Class Specific Code
    this.obj = obj; 
    this.prop = prop; 
    
    // Stub general code
    this.id = Stub.genStubId(); 
    this.hasRealValue = false;
    this.realValue = null;
  
    /*Register the stub object*/ 
    mashic.registerStub(this); 
}

/*=====GADGET_ACCESS_STUB===============================================================================================================================*/
mashic.GadgetAccessStub = mashic.buildAccessStub; 

mashic.IntegratorAccessStub.prototype = new mashic.IntegratorStub(); 

mashic.IntegratorAccessStub.prototype.toMessageObject = function() { 
    var msg =  {msg_type: 'GET_PROPERTY', object : obj, property_name : prop};
    return msg; 
}

/*=====INTEGRATOR_ACCESS_STUB===========================================================================================================================*/
mashic.IntegratorAccessStub = mashic.buildAccessStub; 

mashic.IntegratorAccessStub.prototype = new mashic.IntegratorStub(); 



/*=====GADGET_ACCESS_STUB===============================================================================================================================*/
mashic.IntegratorAccessStub = function(obj, prop) {    
  // Class Specific Code
    this.obj = obj; 
    this.prop = prop; 
    
    // Stub general code
    this.id = Stub.genStubId(); 
    this.hasRealValue = false;
    this.realValue = null;
  
    /*Register the stub object*/ 
    mashic.registerStub(this); 
}

mashic.IntegratorAccessStub.prototype = new mashic.IntegratorStub(); 

mashic.IntegratorAccessStub.prototype.toMessageObject = function() { 
    var msg =  {msg_type: 'GET_PROPERTY', object : obj, property_name : prop};
    return msg; 
}


/*=====CALL=============================================================================================================================================*/


/*
 * Need to implement: 
 * 1) mashic.flushBeforeBuiltinFunction(kont, functionObject, args);   
 * 2) mashic.isAnyArgumentStub(args)
 * 3) mashic.constructArgsUntouch(offset,arguments); -> se houver stubs ja sabes :P 
 */

function __FUNCALL(cont,functionObject) {
    var fun;
    var offset = 2;
    var args = mashic.constructArgsUntouch(offset,arguments);
    
    if (functionObject instanceof mashic.OHandle) {
        return new mashic.FunCallStub(cont, functionObject, args);
    } else if (functionObject instanceof mashic.Stub)) {
        mashic.flushBeforeFunctionCall(cont, functionObject, args); 
    } else {
        mashic.localFunctionCall(cont, functionObject, args); 
    }    
}

mashic.localFunctionCall = function (cont, functionObject, args) { 
    if (functionObject.isCps) {	    
        args.unshift(cont);
        return functionObject.apply(null,args);
    } else {
        if (mashic.isAnyArgumentStub(args)) { 
            mashic.flushBeforeFunctionCall(cont, functionObject, args);   
        } else {
            co0	nt(functionObject.apply(null, args);
        }
    }
}

mashic.FunCallStub = function(cont, functionObject, args) { 
    // Class specific code
    this.functionObject = functionObject; 
    this.cont = cont; 
    this.args = args; 
    // Stub general code
    this.id = Stub.genStubId(); 
    this.hasRealValue = false;
    this.realValue = null; 
    /*Register the stub object*/ 
    mashic.registerStub(this); 
}

mashic.FunCallStub.prototype = new mashic.Stub(); 

mashic.FunCallStub.prototype.toMessageObject = function() { 
     var msg =  {msg_type : 'CALL_FUNCTION', _function : fun, arguments : args};
     return msg; 
}

/*=====ACCSIG===========================================================================================================================================*/

function __ACCSIG(cont, obj, prop, val) { 
    if ((obj instanceof mashic.Stub)||(obj instanceof mashic.OHandle)||
            (prop instanceof mashic.Stub)||(prop instanceof mashic.OHandle)||(val instanceof mashic.Stub)||(val instanceof mashic.OHandle)) {
        
    } else { 
    }
}

function __ACCSIG(frame_id,kont,obj,prop,val){
    if (obj.__is_ohandle && obj.hasOwnProperty('__is_ohandle')){
	return OBJ_PROP_ASSIGN(frame_id,obj,prop,val,kont);
    }else{
	obj[prop]=val;
	return kont(val);
    }
}


