//Data types of object handler of iframe pages
function OHandle(){
    var id = handleIdGen();
    this.id = id;
    this.isOhandle = true;
    return;
}

/// Listener library
//message_handler handles incomming messages
function messageHandler(e){
    var recv = JSON.parse(e.data);
    var requestsArray = recv.requests;
    var answersArray = new Array(requestsArray.length);
    var computeStubsMap = {}; 
    
    for (var i=0; i<requestsArray.length; i++) {
       answersArray[i] = computeRequest(requestsArray[i], computeStubsMap);
       computeStubsMap[requestsArray[i].id] = answersArray[i]; 
    }
       
    var respJson =  JSON.stringify({msgId: recv.id, answers:answersArray});
    e.source.postMessage(respJson,e.origin);
    verbose("I=>O Reply", " : ", respJson);
}

//resigister a callback message_handler on 'message' event 
(function (){
    window.addEventListener("message", messageHandler, false);
})();

//A simple list to store mapping from ohandle to 
var addHandleObj, getObjByHandle;
(function(){

    var handleList = new Object();
    
    addHandleObj = function(ohandle,obj){
        handleList[ohandle.id] = obj;
    };
    
    getObjByHandle = function(ohandle){
        return handleList[ohandle.id];
    };
})();

//response of message: {msgId: -, reqType: GET_GLOBAL_REF, globalName : -}
function getGlobalRef(recv){
    var obj = window[recv.globalName];
    return prepareResponseObject(recv,obj);
}

//response of message: {msg_id: -, reqType: GET_PROPERTY, object : -, propertyName : -}
function getProperty(recv, computedStubsMap){
    var obj, prop; 
    
    obj = recv.object
    if (obj.isShallowStub) {
       obj = computedStubsMap[obj.id];
    } else {
       obj = getObjByHandle(obj);
    }
    
    prop = recv.propertyName; 
    if (prop.isShallowStub) {
       prop = computedStubsMap[prop.id]
    } 
   
    return obj[prop]; 
}

//dispatch function handles the messages
function computeRequest(recvReq, computedStubsMap){  
    var retObj;
    var ohandle;
    switch(recvReq.reqType){
      case 'GET_PROPERTY':
          retObj = getProperty(recvReq, computedStubsMap);
          break;
      case 'GET_REF': 
          retObj = getGlobalRef(recvReq, computedStubsMap); 
          break; 
    }
    if ((retObj != null) && ( ((typeof retObj)== 'object') || ((typeof retObj) == 'function') || ((typeof retObj) == 'array') )){
        ohandle = new OHandle();
        addHandleObj(ohandle,retObj);
        retObj=ohandle;
    }
    return retObj;
}

