/*======================================================================================================================================================*/ 
/*=====ACCESS===========================================================================================================================================*/ 
/*======================================================================================================================================================*/ 

var accessTableMethods = {
    stub: {
        stub:                       function(obj, prop) { return new OAccessStub(obj.getShallowStub(), propobj.getShallowStub());                    }, 
        future:                     function(obj, prop) { return new OAccessFuture(obj, prop);                                                       }, 
        envelope:                   function(obj, prop) { return new OAccessFuture(obj, prop.realValue);                                             },
        real:                       function(obj, prop) { return new OAccessStub(obj.getShallowStub(), prop);                                        }, 
        handle:                     function(obj, prop) { return new OAccessStub(obj.getShallowStub(), prop)                                         } 
    },
  
    future: {
        stub:                       function(obj, prop) { return new OAccessFuture(obj, prop);                                                       }, 
        future:                     function(obj, prop) { return new OAccessFuture(obj, prop);                                                       }, 
        envelope:                   function(obj, prop) { return new OAccessFuture(obj, prop.realValue);                                             },
        real:                       function(obj, prop) { return new OAccessFuture(obj, prop);                                                       }, 
        handle:                     function(obj, prop) { return new OAccessFuture(obj, prop);                                                       } 
    },
  
    envelope: {
        stub:                       function(obj, prop) { return new OAccessStub(obj.realValue, prop.getShallowStub());                              }, 
        future:                     function(obj, prop) { return new OAccessFuture(obj.realValue, prop);                                             }, 
        envelope:                   function(obj, prop) { return obj.realValue[prop.realValue];                                                      },
        real:                       function(obj, prop) { return obj.realValue[prop];                                                                }, 
        handle:                     function(obj, prop) { return new OAccessFuture(obj.realValue, prop);                                             }       
    }, 
  
    real: {
        stub:                       function(obj, prop) { return new OAccessFuture(obj, prop);                                                       }, 
        future:                     function(obj, prop) { return new OAccessFuture(obj, prop);                                                       }, 
        envelope:                   function(obj, prop) { return obj[prop.realValue]                                                                 },
        real:                       function(obj, prop) { return obj[prop];                                                                          }, 
        handle:                     function(obj, prop) { return new OAccessFuture(obj.realValue, prop);                                             } 
    },
  
    ohandle: { 
        stub:                       function(obj, prop) { return new OAccessStub(obj, prop.getShallowStub());                                        }, 
        future:                     function(obj, prop) { return new OAccessFuture(obj, prop);                                                       }, 
        envelope:                   function(obj, prop) { return new OAccessStub(obj, prop.realValue);                                               },
        real:                       function(obj, prop) { return obj[prop];                                                                          }, 
        handle:                     function(obj, prop) { return new OAccessFuture(obj.realValue, prop);                                             }
    }
}

var computeAccessTableMethods = {
    stub: {
        stub:                       function(obj, prop) { this.prototype = stubPrototype;                                                               }, 
        future:                     function(obj, prop) {                                                                                               }, 
        envelope:                   function(obj, prop) { this.prototype = stubPrototype; this.prop = prop.realValue;                                   },
        real:                       function(obj, prop) { this.prototype = stubPrototype;                                                               }, 
        handle:                     function(obj, prop) { this.prototype = stubPrototype;                                                               } 
    },
  
    future: {
        stub:                       function(obj, prop) {                                                                                               }, 
        future:                     function(obj, prop) {                                                                                               }, 
        envelope:                   function(obj, prop) { this.prop = prop.realValue;                                                                   },
        real:                       function(obj, prop) {                                                                                               }, 
        handle:                     function(obj, prop) {                                                                                               } 
    },
  
    envelope: {
        stub:                       function(obj, prop) { this.obj = obj.realValue;                                                                     }, 
        future:                     function(obj, prop) { this.obj = obj.realValue;                                                                     }, 
        envelope:                   function(obj, prop) { 
                                        var realValue = (obj.realValue)[prop.realValue];         
                                        if ((realValue instanceof OStub)||(realValue instanceof OFuture)) { objectCopy(realValue, this) }
                                        else { this.prototype = envelopePrototype; this.realValue = realValue } 
                                                                                                                                                        },
        real:                       function(obj, prop) { 
                                        var realValue = (obj.realValue)[prop];         
                                        if ((realValue instanceof OStub)||(realValue instanceof OFuture)) { objectCopy(realValue, this) }
                                        else { this.prototype = envelopePrototype; this.realValue = realValue } 
                                                                                                                                                        }, 
        handle:                     function(obj, prop) { this.obj = obj.realValue;                                                                     }       
    }, 
  
    real: {
        stub:                       function(obj, prop) {                                                                                               }, 
        future:                     function(obj, prop) {                                                                                               }, 
        envelope:                   function(obj, prop) { 
                                        var realValue = obj[prop.realValue];         
                                        if ((realValue instanceof OStub)||(realValue instanceof OFuture)) { objectCopy(realValue, this) }
                                        else { this.prototype = envelopePrototype; this.realValue = realValue } 
                                                                                                                                                        },
        real:                       function(obj, prop) { 
                                        var realValue = obj[prop];         
                                        if ((realValue instanceof OStub)||(realValue instanceof OFuture)) { objectCopy(realValue, this) }
                                        else { this.prototype = envelopePrototype; this.realValue = realValue } 
                                                                                                                                                        }, 
        handle:                     function(obj, prop) {                                                                                               } 
    },
  
    ohandle: { 
        stub:                       function(obj, prop) { this.prototype = stubPrototype;                                                               }, 
        future:                     function(obj, prop) {                                                                                               }, 
        envelope:                   function(obj, prop) { this.prototype = stubPrototype; this.prop = prop.realValue;                                   },
        real:                       function(obj, prop) { this.prototype = stubPrototype;                                                               }, 
        handle:                     function(obj, prop) { this.prototype = stubPrototype;                                                               }
    }
}

function __ACCESS(obj,prop) {
    alert('i am processing an access'); 
    alert('objType:' + getBatchingType(obj)); 
    alert('propType: '+getBatchingType(prop)); 
    alert('obj: '+ obj); 
    alert('prop: '+prop); 
    var fun = (accessTableMethods[getBatchingType(obj)])[getBatchingType(prop)]; 
    return fun.call(null, obj, prop); 
}

/*=====Stub Code========================================================================================================================================*/ 
function OAccessStub(obj, prop) { 
    // Class Specific Code
    this.obj = obj; 
    this.prop = prop; 
    
    // Stub general code
    this.id = OStub.genStubId();
  
    /*Register the stub object*/ 
    mashicRegister(this); 
}

var accessStubPrototype = new OStub();  

accessStubPrototype.createMsg = function() { 
    return {reqType: 'GET_PROPERTY', object: this.obj, propertyName: this.prop}; 
}

accessStubPrototype.setAnswer = function(answer) {
    if ((typeof answer)=='object') {
        this.prototype = handlePrototype; 
        this.id = answer.id;
        this.isOhandle = true;
    } else { 
        this.prototype = envelopePrototype; 
        this.realValue = answer; 
    } 
}

OAccessStub.prototype = accessStubPrototype;

/*=====Future Code======================================================================================================================================*/
function OAccessFuture(obj, prop) { 
    // Class Specific Code
    this.obj = obj; 
    this.prop = prop; 
  
    /*Register the stub object*/ 
    mashicRegister(this); 
}

OAccessFuture.prototype.compute = function() { 
    var obj = this.obj; 
    var prop = this.prop; 
    var fun = (computeAccessTableMethod[getBatchingType(obj)])[getBatchingType(prop)];
    fun.call(this, obj, prop); 
}

