/*=====Auxiliary Class Methods==========================================================================================================================*/
Object.prototype.batchingType = 'real'; 

var getBatchingType = function(obj) { 
    if((typeof obj) == 'object') return obj.batchingType; 
    else return 'real'; 
}

/*=====STUB ============================================================================================================================================*/
function OStub() { }

OStub.prototype.isStub = true; 

OStub.prototype.batchingType = 'stub'; 

OStub.prototype.setRealValue = function (val) {
    this.prototype = OEnvelope.prototype; 
    this.realValue = val;
}

OStub.prototype.toString = function() { 
     return 'stub  - id: ' + this.id;
}

OStub.genStubId = (function () { 
    var firstId = 1; 
    return function () {
       return firstId++; 
    }
})(); 

OStub.prototype.getShallowStub = function () { 
    return { id: this.id, isShallowStub: true };
}

/*=====Future ==========================================================================================================================================*/
function OFuture() { }

OFuture.prototype.isFuture = true; 

OFuture.prototype.batchingType = 'future'; 

var futurePrototype = new OFuture; 

OFuture.prototype.toString = function() { 
     return 'future';
}

/*=====Envelope ========================================================================================================================================*/
function OEnvelope() { }

OEnvelope.prototype.isFuture = true; 

OEnvelope.prototype.batchingType = 'envelope';

var envelopePrototype = new OEnvelope; 

OEnvelope.prototype.toString = function() { 
     return 'Envelope - value: ' + this.realValue;
}

/*=====Handler==========================================================================================================================================*/
function OHandle(){
    var id = handleIdGen();
    this.id = id;
    this.isOhandle = true;
    return;
}

OHandle.prototype.batchingType = 'handle';

var handlePrototype = new OHandle; 

OHandle.prototype.toString = function() { 
    return 'OHandle - id: ' + this.id; 
}

/*=====Main Methods=====================================================================================================================================*/
var stubsArray=new Array;
var stopStubsArrayIndex=0; 

function mashicRegister(obj) { 
   stubsArray.push(obj); 
   stopStubsArrayIndex++; 
}

/*Function that processes the response from the gadget...*/
function messageHandler(e){
    var recv = JSON.parse(e.data);
    var val; 
  
    // update the stubs
    var answersArray = recv.answers;
    var cont = getCont(recv.msgId);
   
    for (var i=0; i<answersArray.length; i++) {
        stubsArray[i].setAnswer(answersArray[i]); 
    }
  
    // computing the futures
    if(stopStubsArrayIndex < stubsArray.length) {
        var j=stopStubsArrayIndex; 
        while (j< stubsArray.length) {
            var currentObj = subsArray[j]; 
            if (!(currentObj instanceof OFuture)) break; 
            currentFuture.compute(); 
            if ( (currentObj instanceof OStub) || (currentObj instanceof OFuture) ) break;  
            j++; 
        }
        stubsArray = stubsArray.slice(j); 
        if (j < stubsArray.length) {
            __FLUSH(cont);
        }
    }
    
    if(cont) cont.call(null); 
}

function __FLUSH(){
    var cont = arguments[0]; 
    var msgObj = { msgId:msgIdGen() };
    var requests = new Array; 
    var i = 0; 
    
    while ((i< stubsArray.length)&&(stubsArray[i] instanceof OStub)) { 
      msg = stubsArray[i].createMsg(); 
      requests[i] = msg;
      i++; 
    }
    msgObj.requests = requests; 
    
    if (i!=0) { 
       postMsg(msgObj);
       stopStubsArrayIndex = i; 
       setCont(null, msgObj.msgId, cont);
    }
}
 
//Proxy Library

//parameters
var untrustedOrigin="*";
var untrustedIframe=false;
var untrustedIframeId='widget';

//Initailize the list for storing continuations and callback functions
var setCont;
var getCont;
var getSrc;

(function(){
    var contList = new Object();
    var srcList = new Object();

    //Set continuations
    setCont = function(frameId, msgId,cont){
        contList[msgId.toString()] = cont;
        srcList[msgId.toString()] = frameId; 
    }
    
    //Get continuations
    getCont = function(msgId){
        return contList[msgId.toString()];
    }

    //Get frame of the gadget that send the message!!!!
    getSrc = function(msgId){
        return document.getElementById(srcList[msgId.toString()]).contentWindow;
    }
})();

(function(){
    window.addEventListener("message", messageHandler, false);
})();

function postMsg(message, frameId){
    var jsonMessage; 
    if (frameId == undefined){
        if (!untrustedIframe) {
            alert(untrustedIframeId); 
            untrustedIframe = document.getElementById(untrustedIframeId).contentWindow;
        } 
        jsonMessage =  JSON.stringify(message);
        verbose("O=>I Request", " : ", jsonMessage);
        untrustedIframe.postMessage(jsonMessage,untrustedOrigin);
    } else {
        var targetIframe = document.getElementById(frameId).contentWindow;
        jsonMessage =  JSON.stringify(message);
        verbose("O=>I Request", " : ", jsonMessage);
        targetIframe.postMessage(jsonMessage,untrustedOrigin);
    }
}